package org.example;

import org.springframework.stereotype.Service;

import jakarta.annotation.PostConstruct;
import jakarta.annotation.PreDestroy;

@Service
public class HelloService {

	private static final int ADULT_AGE = 20;

	private final GreetingService greetingService;

	public HelloService(GreetingService greetingService) {
		this.greetingService = greetingService;
	}

	public String sayHello(String name, int age) {
		if (age < ADULT_AGE)
			return "Hello " + name + "!";
		else return greetingService.getGreeting() + ", " + name + "!";
	}

	@PostConstruct
	public void init() {
		System.out.println("--- HelloService: init");
	}

	@PreDestroy
	public void cleanup() {
		System.out.println("--- HelloService: cleanup");
	}
}
